<template>
  <div>
    <v-dialog v-model="mostrarAdvertencia" persistent max-width="800">
      <v-card>
        <div class="contSecc">
          <div class="titSec font-size-13">Advertencia</div>
          <div class="gris">
            <div class="titCol titDialog">
              Una vez creada la ficha no podrá cambiar el tipo de formato
            </div>
          </div>
        </div>
        <div class="btnCenter">
          <button class="btn btnG" @click="cancelarAlerta">Cancelar</button>
          <button class="btn" @click="crearFicha">Aceptar</button>
        </div>
      </v-card>
    </v-dialog>

    <v-dialog v-model="mostrarAdvertencia2" persistent max-width="800">
      <v-card>
        <div class="contSecc">
          <div class="titSec font-size-13">Advertencia</div>
          <div class="gris">
            <div class="titCol titDialog">
              Ya existe ficha sucursal con otro documento tipo de documeto
            </div>
          </div>
        </div>
        <div class="btnCenter">
          <button class="btn" @click="cancelarAlerta">Aceptar</button>
        </div>
      </v-card>
    </v-dialog>

    <div class="contSecc">
      <div class="titSecCard">Datos Ficha Sucursal</div>
    </div>
    <v-row>
      <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
        <v-textarea
          v-model="data.region"
          label="Región"
          ref="txtRegion"
          readonly
          rows="1"
        />
      </v-col>

      <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
        <v-textarea
          v-model="data.zona"
          label="Zona"
          ref="txtZona"
          readonly
          rows="1"
        />
      </v-col>

      <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
        <v-textarea
          v-model="data.territorio"
          label="Territorio"
          ref="txtTerritorio"
          readonly
          rows="1"
        />
      </v-col>
    </v-row>
    <div>
      <v-text-field
        label="Longitud"
        rows="1"
        placeholder="Digita la Longitud"
        v-model="data.longitud"
        counter="50"
        maxlength="50"
        type="number"
        ref="txtLongitud"
        clearable
        @click="activarBotonModificar(true)"
      />
    </div>
    <div>
      <v-text-field
        label="Latitud"
        rows="1"
        placeholder="Digita la Latitud"
        v-model="data.latitud"
        counter="50"
        maxlength="50"
        type="number"
        ref="txtLatitud"
        clearable
        @click="activarBotonModificar(true)"
      />
    </div>
    <div>
      <v-text-field
        label="Dirección"
        rows="1"
        placeholder="Digita la Dirección"
        v-model="data.direccion"
        counter="200"
        maxlength="200"
        ref="txtDireccion"
        clearable
        @click="activarBotonModificar(true)"
      />
    </div>
    <div>
      <v-row>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <button
            class="btn btnG"
            @click="activarBotonModificar(false)"
            v-if="modificoFicha"
          >
            Cancelar
          </button>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <button class="btn" @click="guardarActualizar" v-if="modificoFicha">
            Guardar
          </button>
        </v-col>
      </v-row>
    </div>
  </div>
</template>

<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-CardFichaSucursal",
  props: {
    value: Object,
    callback: { type: Function },
    borrarDatos: { type: Function },
  },
  created() {
    this.mostrarAdvertencia = false;
    this.crearFichaVacia();
  },
  data() {
    return {
      ficha: [],
      existeFicha: false,
      fichaTipo: false,
      modificoFicha: false,
      mostrarAdvertencia: false,
      mostrarAdvertencia2: false,
    };
  },
  computed: {
    data: {
      get() {
        return this.value.dataFichaSucursal;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    clearInputText() {
      this.$refs.txtLatitud.clearableCallback();
      this.$refs.txtLongitud.clearableCallback();
      this.$refs.txtDireccion.clearableCallback();
      this.$refs.txtZona.clearableCallback();
      this.$refs.txtRegion.clearableCallback();
      this.$refs.txtTerritorio.clearableCallback();
      this.modificoFicha = false;
      this.fichaTipo = false;
    },

    getFicha() {
      var self = this;
      var ceco = this.value.dataCeco.ceco;
      this.modificoFicha = false;
      this.existeFicha = false;
      axios("/documento-sucursal/ceco/v1/busquedas/geografia/" + ceco)
        .then((response) => {
          let data = response.data;
          if (data) {
            self.ficha = data.resultado.geografias;
            this.validar();
          }
        })
        .catch((error) => {
          if (error.response) {
            self.ficha = [];
            this.validar();
            console.log(error.response.data);
          }
        });
    },

    retornaDatosFicha() {
      if (this.ficha != null && this.ficha.length > 0) {
        return this.ficha[0];
      } else {
        return null;
      }
    },

    validar() {
      var datosEncontrados = this.retornaDatosFicha();
      if (datosEncontrados != null) {
        if (datosEncontrados.datosFicha != null) {
          this.existeFicha = true;
        } else {
          this.existeFicha = false;
        }

        this.crearFichaVacia();
        this.seteaEsencial();
        this.validaFichaDocumento();
      } else {
        this.crearFichaVacia();
        this.seteaEsencial();
        this.existeFicha = false;
        this.activarBotonModificar(true);
      }
    },

    crearFichaVacia() {
      this.value.dataFichaSucursal = {
        direccion: "",
        idFicha: 0,
        idFolio: 0,
        idFormato: 0,
        idNegocio: 0,
        latitud: "",
        longitud: "",
      };
    },

    seteaEsencial() {
      var datosEncontrados = this.retornaDatosFicha();
      this.value.dataFichaSucursal.idFormato =
        this.value.dataFormato.value.idFormato;
      this.value.dataFichaSucursal.idNegocio =
        this.value.dataUnidadNegocio.value.idNegocio;
      this.value.dataFichaSucursal.idCeco = this.value.dataCeco.ceco;
      try {
        if (datosEncontrados != null) {
          this.value.dataFichaSucursal.idRegion = datosEncontrados.idRegion;
          this.value.dataFichaSucursal.idTerritorio =
            datosEncontrados.idTerritorio;
          this.value.dataFichaSucursal.idZona = datosEncontrados.idZona;
          this.value.dataFichaSucursal.zona = datosEncontrados.zona;
          this.value.dataFichaSucursal.territorio = datosEncontrados.territorio;
          this.value.dataFichaSucursal.region = datosEncontrados.region;

          if (datosEncontrados.datosFicha != null) {
            this.value.dataFichaSucursal.direccion =
              datosEncontrados.datosFicha.direccion;
            this.value.dataFichaSucursal.idFicha =
              datosEncontrados.datosFicha.idFicha;
            this.value.dataFichaSucursal.idFolio =
              datosEncontrados.datosFicha.idFolio;
            this.value.dataFichaSucursal.latitud =
              datosEncontrados.datosFicha.latitud;
            this.value.dataFichaSucursal.longitud =
              datosEncontrados.datosFicha.longitud;
          }
        }
      } catch (ex) {
        console.error("outer", ex.message);
      }
    },

    validaFichaDocumento() {
      var datosEncontrados = this.retornaDatosFicha();
      if (datosEncontrados != null && datosEncontrados.datosFicha != null) {
        if (
          datosEncontrados.datosFicha.idFormato ==
          this.value.dataFormato.value.idFormato
        ) {
          this.fichaTipo = true;
          this.callback();
        } else {
          this.borrarDatos(4);
          this.mostrarAdvertencia2 = true;
        }
      } else {
        this.modificoFicha = true;
      }
    },

    activarBotonModificar(valor) {
      if (this.existeFicha) {
        if (this.fichaTipo) {
          this.modificoFicha = valor;
        }
      } else {
        if (this.value.dataFormato.value != null) {
          this.modificoFicha = valor;
        }
      }
    },

    guardarActualizar() {
      if (this.existeFicha) {
        this.actualizarFicha();
      } else {
        this.mostrarAdvertencia = true;
      }
    },

    cancelarAlerta() {
      this.mostrarAdvertencia = false;
      this.mostrarAdvertencia2 = false;
    },

    actualizarFicha() {
      var idFicha = this.value.dataFichaSucursal.idFicha;
      axios
        .put("/documento-sucursal/ficha/v1/" + idFicha, {
          idCeco: this.value.dataFichaSucursal.idCeco,
          idNegocio: this.value.dataFichaSucursal.idNegocio,
          idFormato: this.value.dataFichaSucursal.idFormato,
          latitud: this.value.dataFichaSucursal.latitud,
          longitud: this.value.dataFichaSucursal.longitud,
          direccion: this.value.dataFichaSucursal.direccion,
        })
        .then((response) => {
          let data = response.data;
          if (data) {
            this.getFicha();
          } else {
            alert("No se actualizo");
          }
        })
        .catch((error) => {
          if (error.response) {
            if (error.response.status == 404) {
              alert("No se actualizo");
            }
            console.log(error.response.data);
          }
        });
    },
    crearFicha() {
      axios
        .post("/documento-sucursal/ficha/v1/", {
          idCeco: this.value.dataFichaSucursal.idCeco,
          idNegocio: this.value.dataFichaSucursal.idNegocio,
          idFormato: this.value.dataFichaSucursal.idFormato,
          latitud: this.value.dataFichaSucursal.latitud,
          longitud: this.value.dataFichaSucursal.longitud,
          direccion: this.value.dataFichaSucursal.direccion,
        })
        .then((response) => {
          let data = response.data;
          if (data) {
            this.getFicha();
            this.mostrarAdvertencia = false;
            this.callback();
          } else {
            alert("No se actualizo");
          }
        })
        .catch((error) => {
          if (error.response) {
            if (error.response.status == 404) {
              alert("No se actualizo");
            }
            console.log(error.response.data);
          }
        });
    },
  },
};
</script>

<style lang="scss" scoped></style>
